Index: /LMDZ6/branches/cirrus/arch/arch-X64_JEANZAY.path
===================================================================
--- /LMDZ6/branches/cirrus/arch/arch-X64_JEANZAY.path	(revision 5201)
+++ /LMDZ6/branches/cirrus/arch/arch-X64_JEANZAY.path	(revision 5202)
@@ -1,30 +1,21 @@
-# $Id$
-#NETCDF_LIBDIR="-L$NETCDFFORTRAN_LIBDIR -L$NETCDF_LIBDIR -lnetcdf -lnetcdff"
-#NETCDF_INCDIR=-I$NETCDFFORTRAN_INCDIR
-NETCDF_INCDIR=""
-NETCDF_LIBDIR=""
+NETCDF_INCDIR="-I$(nf-config --includedir) -I$(nc-config --includedir)"  # nc required for xios
+# Ugly hack for orchidee <=2.0
+NETCDF_LIBDIR="-L$(nf-config --flibs | sed -e "s/-L//")"
 NETCDF_LIB="-lnetcdff -lnetcdf"
+NETCDF95_INCDIR="-I$(pwd)/../../include"
+NETCDF95_LIBDIR="-L$(pwd)/../../lib"
+NETCDF95_LIB="-lnetcdf95"
 
-NETCDF95_INCDIR=-I$NETCDF95_ROOT/include/NetCDF95
-NETCDF95_LIBDIR=-L$NETCDF95_ROOT/lib
-NETCDF95_LIB=-lnetcdf95
-
-IOIPSL_INCDIR="-I$LMDGCM/../../lib -I$LMDGCM/../IOIPSL/inc"
-IOIPSL_LIBDIR="-L$LMDGCM/../../lib -L$LMDGCM/../IOIPSL/lib"
+# Exported
+IOIPSL_INCDIR="-I$(pwd)/../IOIPSL/inc -I$(pwd)/../IOIPSL/lib"
+IOIPSL_LIBDIR="-L$(pwd)/../IOIPSL/inc -L$(pwd)/../IOIPSL/lib"
 IOIPSL_LIB="-lioipsl"
 
-XIOS_INCDIR="-I$LMDGCM/../XIOS/inc"
-XIOS_LIBDIR="-L$LMDGCM/../XIOS/lib"
+# Exported
+XIOS_INCDIR="-I$(pwd)/../XIOS/inc"
+XIOS_LIBDIR="-L$(pwd)/../XIOS/lib"
 XIOS_LIB="-lxios -lstdc++"
 
-ORCH_INCDIR="-I$LMDGCM/../../lib"
-ORCH_LIBDIR="-L$LMDGCM/../../lib"
-ORCH_LIB=
-
-OASIS_INCDIR="-I$LMDGCM/../../oasis3-mct/BLD/build/lib/psmile.MPI1"
-OASIS_LIBDIR="-L$LMDGCM/../../oasis3-mct/BLD/lib"
-OASIS_LIB="-lpsmile.MPI1 -lscrip -lmct -lmpeu"
-
-INCA_INCDIR="-I$LMDGCM/../INCA/build/inc"
-INCA_LIBDIR="-L$LMDGCM/../INCA/build/lib"
-INCA_LIB="-lchimie"
+# Exported
+ORCH_INCDIR="-I$(pwd)/../ORCHIDEE/inc -I$(pwd)/../ORCHIDEE/lib"
+ORCH_LIBDIR="-L$(pwd)/../ORCHIDEE/inc -L$(pwd)/../ORCHIDEE/lib"
Index: /LMDZ6/branches/cirrus/arch/arch-X64_MESOIPSL-GNU.env
===================================================================
--- /LMDZ6/branches/cirrus/arch/arch-X64_MESOIPSL-GNU.env	(revision 5202)
+++ /LMDZ6/branches/cirrus/arch/arch-X64_MESOIPSL-GNU.env	(revision 5202)
@@ -0,0 +1,8 @@
+module purge
+module load subversion/1.13.0
+module load gcc/11.2.0
+module load openmpi/4.0.7
+module load hdf5/1.10.7-mpi
+module load netcdf-fortran/4.5.3-mpi
+module load netcdf-c/4.7.4-mpi
+module load netcdf95
Index: /LMDZ6/branches/cirrus/arch/arch-X64_MESOIPSL-GNU.fcm
===================================================================
--- /LMDZ6/branches/cirrus/arch/arch-X64_MESOIPSL-GNU.fcm	(revision 5202)
+++ /LMDZ6/branches/cirrus/arch/arch-X64_MESOIPSL-GNU.fcm	(revision 5202)
@@ -0,0 +1,35 @@
+%COMPILER            mpif90
+%CCOMPILER           mpicc  # xios
+%LINK                mpif90
+%FPP                 cpp
+%AR                  ar
+%ARFLAGS             rU
+%MAKE                make
+%FPP_FLAGS           -P -traditional
+%FPP_DEF             NC_DOUBLE
+
+%BASE_FFLAGS         -cpp -ffree-line-length-0 -fdefault-real-8 -DNC_DOUBLE -fallow-argument-mismatch
+%BASE_CFLAGS         -w -std=c++11 -D__XIOS_EXCEPTION  # xios
+# /!\ LD must be written in Makefile syntax
+%BASE_LD             -Wl,-rpath=$(shell nf-config --prefix)/lib -lstdc++
+%BASE_INC            -D__NONE__  # xios
+
+%PROD_FFLAGS         -O3 -march=native
+%PROD_CFLAGS         -O3 -DBOOST_DISABLE_ASSERTS  # xios
+
+%DEV_FFLAGS          -Wall -fbounds-check
+%DEV_CFLAGS          -g -O2  # xios
+
+%DEBUG_FFLAGS        -g3 -Wall -fbounds-check -ffpe-trap=invalid,zero,overflow -O0 -fstack-protector-all -fbacktrace -finit-real=snan
+%DEBUG_CFLAGS        -g -DBZ_DEBUG # xios
+
+%MPI_FFLAGS          -fcray-pointer
+%MPI_LD              -L$(shell dirname $(shell readlink -f "$(shell which mpif90)"))/../lib -lmpi
+%OMP_LD              -fopenmp
+%OMP_FFLAGS          -fopenmp -fcray-pointer
+
+%CPP                 cpp  # xios
+%FPP                 cpp -P  # xios
+%MAKE                make  # xios
+
+
Index: /LMDZ6/branches/cirrus/arch/arch-X64_MESOIPSL-GNU.path
===================================================================
--- /LMDZ6/branches/cirrus/arch/arch-X64_MESOIPSL-GNU.path	(revision 5202)
+++ /LMDZ6/branches/cirrus/arch/arch-X64_MESOIPSL-GNU.path	(revision 5202)
@@ -0,0 +1,21 @@
+NETCDF_INCDIR="-I$(nf-config --includedir) -I$(nc-config --includedir)"  # nc required for xios
+# Ugly hack for orchidee <=2.0
+NETCDF_LIBDIR="-L$(nf-config --flibs | sed -e "s/-L//")"
+NETCDF_LIB="-lnetcdff -lnetcdf"
+NETCDF95_INCDIR="-I$(pwd)/../../include"
+NETCDF95_LIBDIR="-L$(pwd)/../../lib"
+NETCDF95_LIB="-lnetcdf95"
+
+# Exported
+IOIPSL_INCDIR="-I$(pwd)/../IOIPSL/inc -I$(pwd)/../IOIPSL/lib"
+IOIPSL_LIBDIR="-L$(pwd)/../IOIPSL/inc -L$(pwd)/../IOIPSL/lib"
+IOIPSL_LIB="-lioipsl"
+
+# Exported
+XIOS_INCDIR="-I$(pwd)/../XIOS/inc"
+XIOS_LIBDIR="-L$(pwd)/../XIOS/lib"
+XIOS_LIB="-lxios -lstdc++"
+
+# Exported
+ORCH_INCDIR="-I$(pwd)/../ORCHIDEE/inc -I$(pwd)/../ORCHIDEE/lib"
+ORCH_LIBDIR="-L$(pwd)/../ORCHIDEE/inc -L$(pwd)/../ORCHIDEE/lib"
Index: /LMDZ6/branches/cirrus/arch/arch-local-gfortran-parallel.env
===================================================================
--- /LMDZ6/branches/cirrus/arch/arch-local-gfortran-parallel.env	(revision 5202)
+++ /LMDZ6/branches/cirrus/arch/arch-local-gfortran-parallel.env	(revision 5202)
@@ -0,0 +1,1 @@
+# empty
Index: /LMDZ6/branches/cirrus/arch/arch-local-gfortran-parallel.fcm
===================================================================
--- /LMDZ6/branches/cirrus/arch/arch-local-gfortran-parallel.fcm	(revision 5202)
+++ /LMDZ6/branches/cirrus/arch/arch-local-gfortran-parallel.fcm	(revision 5202)
@@ -0,0 +1,33 @@
+%COMPILER            mpif90
+%CCOMPILER           mpicc  # xios
+%LINK                mpif90
+%FPP                 cpp
+%AR                  ar
+%ARFLAGS             rU
+%MAKE                make
+%FPP_FLAGS           -P -traditional
+%FPP_DEF             NC_DOUBLE
+
+%BASE_FFLAGS         -cpp -ffree-line-length-0 -fdefault-real-8 -DNC_DOUBLE -fallow-argument-mismatch -fimplicit-none
+%BASE_CFLAGS         -w -std=c++11 -D__XIOS_EXCEPTION  # xios
+# /!\ LD must be written in Makefile syntax
+%BASE_LD             -Wl,-rpath=$(shell nf-config --prefix)/lib -lstdc++
+%BASE_INC            -D__NONE__  # xios
+
+%PROD_FFLAGS         -O3 -march=native
+%PROD_CFLAGS         -O3 -DBOOST_DISABLE_ASSERTS  # xios
+
+%DEV_FFLAGS          -Wall -fbounds-check
+%DEV_CFLAGS          -g -O2  # xios
+
+%DEBUG_FFLAGS        -g3 -Wall -fbounds-check -ffpe-trap=invalid,zero,overflow -O0 -fstack-protector-all -fbacktrace -finit-real=snan
+%DEBUG_CFLAGS        -g -DBZ_DEBUG # xios
+
+%MPI_FFLAGS          -fcray-pointer
+%MPI_LD              -L$(shell dirname $(shell readlink -f "$(shell which mpif90)"))/../lib -lmpi
+%OMP_LD              -fopenmp
+%OMP_FFLAGS          -fopenmp -fcray-pointer
+
+%CPP                 cpp  # xios
+
+
Index: /LMDZ6/branches/cirrus/arch/arch-local-gfortran-parallel.path
===================================================================
--- /LMDZ6/branches/cirrus/arch/arch-local-gfortran-parallel.path	(revision 5202)
+++ /LMDZ6/branches/cirrus/arch/arch-local-gfortran-parallel.path	(revision 5202)
@@ -0,0 +1,21 @@
+NETCDF_INCDIR="-I$(nf-config --includedir) -I$(nc-config --includedir)"  # nc required for xios
+# Ugly hack for orchidee <=2.0
+NETCDF_LIBDIR="-L$(nf-config --flibs | sed -e "s/-L//")"
+NETCDF_LIB="-lnetcdff -lnetcdf"
+NETCDF95_INCDIR="-I$(pwd)/../../include"
+NETCDF95_LIBDIR="-L$(pwd)/../../lib"
+NETCDF95_LIB="-lnetcdf95"
+
+# Exported
+IOIPSL_INCDIR="-I$(pwd)/../IOIPSL/inc -I$(pwd)/../IOIPSL/lib"
+IOIPSL_LIBDIR="-L$(pwd)/../IOIPSL/inc -L$(pwd)/../IOIPSL/lib"
+IOIPSL_LIB="-lioipsl"
+
+# Exported
+XIOS_INCDIR="-I$(pwd)/../XIOS/inc"
+XIOS_LIBDIR="-L$(pwd)/../XIOS/lib"
+XIOS_LIB="-lxios -lstdc++"
+
+# Exported
+ORCH_INCDIR="-I$(pwd)/../ORCHIDEE/inc -I$(pwd)/../ORCHIDEE/lib"
+ORCH_LIBDIR="-L$(pwd)/../ORCHIDEE/inc -L$(pwd)/../ORCHIDEE/lib"
Index: /LMDZ6/branches/cirrus/arch/arch-local-gfortran.env
===================================================================
--- /LMDZ6/branches/cirrus/arch/arch-local-gfortran.env	(revision 5202)
+++ /LMDZ6/branches/cirrus/arch/arch-local-gfortran.env	(revision 5202)
@@ -0,0 +1,1 @@
+# empty
Index: /LMDZ6/branches/cirrus/arch/arch-local-gfortran.fcm
===================================================================
--- /LMDZ6/branches/cirrus/arch/arch-local-gfortran.fcm	(revision 5202)
+++ /LMDZ6/branches/cirrus/arch/arch-local-gfortran.fcm	(revision 5202)
@@ -0,0 +1,18 @@
+%COMPILER            gfortran
+%LINK                gfortran
+%FPP                 cpp
+%AR                  ar
+%ARFLAGS             rU
+%MAKE                make
+%FPP_FLAGS           -P -traditional
+%FPP_DEF             NC_DOUBLE
+%BASE_FFLAGS         -cpp -ffree-line-length-0 -fdefault-real-8 -DNC_DOUBLE -fallow-argument-mismatch -fimplicit-none
+%PROD_FFLAGS         -O3 -march=native
+%DEV_FFLAGS          -Wall -fbounds-check
+%DEBUG_FFLAGS        -g3 -Wall -fbounds-check -ffpe-trap=invalid,zero,overflow -O0 -fstack-protector-all -fbacktrace -finit-real=snan
+%MPI_FFLAGS
+%OMP_FFLAGS
+# /!\ LD must be written in Makefile syntax
+%BASE_LD             -Wl,-rpath=$(shell nf-config --prefix)/lib
+%MPI_LD
+%OMP_LD
Index: /LMDZ6/branches/cirrus/arch/arch-local-gfortran.path
===================================================================
--- /LMDZ6/branches/cirrus/arch/arch-local-gfortran.path	(revision 5202)
+++ /LMDZ6/branches/cirrus/arch/arch-local-gfortran.path	(revision 5202)
@@ -0,0 +1,21 @@
+NETCDF_INCDIR="-I$(nf-config --includedir) -I$(nc-config --includedir)"  # nc required for xios
+# Ugly hack for orchidee <=2.0
+NETCDF_LIBDIR="-L$(nf-config --flibs | sed -e "s/-L//")"
+NETCDF_LIB="-lnetcdff -lnetcdf"
+NETCDF95_INCDIR="-I$(pwd)/../../include"
+NETCDF95_LIBDIR="-L$(pwd)/../../lib"
+NETCDF95_LIB="-lnetcdf95"
+
+# Exported
+IOIPSL_INCDIR="-I$(pwd)/../IOIPSL/inc -I$(pwd)/../IOIPSL/lib"
+IOIPSL_LIBDIR="-L$(pwd)/../IOIPSL/inc -L$(pwd)/../IOIPSL/lib"
+IOIPSL_LIB="-lioipsl"
+
+# Exported
+XIOS_INCDIR="-I$(pwd)/../XIOS/inc"
+XIOS_LIBDIR="-L$(pwd)/../XIOS/lib"
+XIOS_LIB="-lxios -lstdc++"
+
+# Exported
+ORCH_INCDIR="-I$(pwd)/../ORCHIDEE/inc -I$(pwd)/../ORCHIDEE/lib"
+ORCH_LIBDIR="-L$(pwd)/../ORCHIDEE/inc -L$(pwd)/../ORCHIDEE/lib"
Index: /LMDZ6/branches/cirrus/libf/dyn3d/check_isotopes.F90
===================================================================
--- /LMDZ6/branches/cirrus/libf/dyn3d/check_isotopes.F90	(revision 5201)
+++ /LMDZ6/branches/cirrus/libf/dyn3d/check_isotopes.F90	(revision 5202)
@@ -23,4 +23,5 @@
                              iso_O17, iso_HTO
    LOGICAL, SAVE :: first=.TRUE.
+   LOGICAL, PARAMETER :: tnat1=.TRUE.
 
    modname='check_isotopes'
@@ -34,5 +35,9 @@
       iso_O17 = strIdx(isoName,'H217O')
       iso_HTO = strIdx(isoName,'HTO')
-      IF(getKey('tnat', tnat)) CALL abort_gcm(modname, 'missing isotopic parameter', 1)
+      if (tnat1) then
+              tnat(:)=1.0
+      else
+         IF(getKey('tnat', tnat)) CALL abort_gcm(modname, 'missing isotopic parameter', 1)
+      endif
       first = .FALSE.
    END IF
Index: /LMDZ6/branches/cirrus/libf/dyn3d/conf_gcm.F90
===================================================================
--- /LMDZ6/branches/cirrus/libf/dyn3d/conf_gcm.F90	(revision 5201)
+++ /LMDZ6/branches/cirrus/libf/dyn3d/conf_gcm.F90	(revision 5202)
@@ -18,5 +18,5 @@
   USE logic_mod, ONLY: fxyhypb, iflag_phys, ok_etat0, ok_gradsfile, &
                        ok_guide, ok_limit, ok_strato, purmats, read_start, &
-                       ysinus, read_orop
+                       ysinus, read_orop, adv_qsat_liq
   USE serre_mod, ONLY: clon,clat,grossismx,grossismy,dzoomx,dzoomy, &
                        alphax,alphay,taux,tauy
@@ -606,4 +606,13 @@
      type_trac = 'lmdz'
      CALL getin('type_trac',type_trac)
+
+
+     !Config  Key  = adv_qsat_liq
+     !Config  Desc = option for qsat calculation in the dynamics
+     !Config  Def  = n 
+     !Config  Help = controls which phase is considered for qsat calculation 
+     !Config          
+     adv_qsat_liq = .FALSE.
+     CALL getin('adv_qsat_liq',adv_qsat_liq)
 
      !Config  Key  = ok_dynzon 
@@ -672,4 +681,5 @@
      write(lunout,*)' ok_dyn_ins = ', ok_dyn_ins 
      write(lunout,*)' ok_dyn_ave = ', ok_dyn_ave 
+     write(lunout,*)' adv_qsat_liq = ', adv_qsat_liq
   ELSE
      !Config  Key  = clon
Index: /LMDZ6/branches/cirrus/libf/dyn3d/dynetat0.F90
===================================================================
--- /LMDZ6/branches/cirrus/libf/dyn3d/dynetat0.F90	(revision 5201)
+++ /LMDZ6/branches/cirrus/libf/dyn3d/dynetat0.F90	(revision 5202)
@@ -43,4 +43,5 @@
   REAL    :: time, tnat, alpha_ideal, tab_cntrl(length)    !--- RUN PARAMS TABLE
   LOGICAL :: lSkip, ll
+  LOGICAL,PARAMETER :: tnat1=.TRUE.
 !-------------------------------------------------------------------------------
   modname="dynetat0"
@@ -155,6 +156,12 @@
       iqParent = tracers(iq)%iqParent
       IF(tracers(iq)%iso_iZone == 0) THEN
-         IF(getKey('tnat', tnat, isoName(iName)) .OR. getKey('alpha', alpha_ideal, isoName(iName))) &
+         if (tnat1) then
+                 tnat=1.0
+                 alpha_ideal=1.0
+                 write(*,*) 'attention dans dynetat0: les alpha_ideal sont a 1'
+         else
+          IF(getKey('tnat', tnat, isoName(iName)) .OR. getKey('alpha', alpha_ideal, isoName(iName))) &
             CALL abort_gcm(TRIM(modname), 'missing isotopic parameters', 1)
+         endif
          CALL msg('Tracer <'//TRIM(var)//'> is missing => initialized with a simplified Rayleigh distillation law.', modname)
          q(:,:,:,iq) = q(:,:,:,iqParent)*tnat*(q(:,:,:,iqParent)/30.e-3)**(alpha_ideal-1.)
Index: /LMDZ6/branches/cirrus/libf/dyn3d/dynredem_mod.F90
===================================================================
--- /LMDZ6/branches/cirrus/libf/dyn3d/dynredem_mod.F90	(revision 5201)
+++ /LMDZ6/branches/cirrus/libf/dyn3d/dynredem_mod.F90	(revision 5202)
@@ -4,5 +4,5 @@
   PRIVATE
   PUBLIC :: dynredem_write_u, dynredem_write_v, dynredem_read_u, err
-  PUBLIC :: cre_var, get_var1, put_var1, put_var2, fil, modname, msg
+  PUBLIC :: cre_var, put_var1, put_var2, fil, modname, msg
   include "dimensions.h"
   include "paramet.h"
Index: /LMDZ6/branches/cirrus/libf/dyn3d/iniacademic.F90
===================================================================
--- /LMDZ6/branches/cirrus/libf/dyn3d/iniacademic.F90	(revision 5201)
+++ /LMDZ6/branches/cirrus/libf/dyn3d/iniacademic.F90	(revision 5202)
@@ -80,4 +80,5 @@
 
   REAL zdtvr, tnat, alpha_ideal
+  LOGICAL,PARAMETER :: tnat1=.true.
   
   character(len=*),parameter :: modname="iniacademic"
@@ -321,10 +322,22 @@
               iqParent = tracers(iq)%iqParent
               IF(tracers(iq)%iso_iZone == 0) THEN
-                 IF(getKey('tnat', tnat, isoName(iName)) .OR. getKey('alpha', alpha_ideal, isoName(iName))) &
+                 if (tnat1) then
+                         tnat=1.0
+                         alpha_ideal=1.0
+                         write(*,*) 'Attention dans iniacademic: alpha_ideal=1'
+                 else
+                    IF(getKey('tnat', tnat, isoName(iName)) .OR. getKey('alpha', alpha_ideal, isoName(iName))) &
                     CALL abort_gcm(TRIM(modname), 'missing isotopic parameters', 1)
+                 endif
                  q(:,:,iq) = q(:,:,iqParent)*tnat*(q(:,:,iqParent)/30.e-3)**(alpha_ideal-1.)
-              ELSE
-                 q(:,:,iq) = q(:,:,iqIsoPha(iName,iPhase))
-              END IF
+              ELSE !IF(tracers(iq)%iso_iZone == 0) THEN
+                 IF(tracers(iq)%iso_iZone == 1) THEN
+                    ! correction le 14 mai 2024 pour que tous les traceurs soient de la couleur 1.
+                    ! Sinon, on va avoir des porblèmes de conservation de masse de traceurs.
+                    q(:,:,iq) = q(:,:,iqIsoPha(iName,iPhase))
+                 else !IF(tracers(iq)%iso_iZone == 1) THEN
+                    q(:,:,iq) = 0.
+                 endif !IF(tracers(iq)%iso_iZone == 1) THEN
+              END IF !IF(tracers(iq)%iso_iZone == 0) THEN
            enddo
         else
Index: /LMDZ6/branches/cirrus/libf/dyn3d/logic_mod.F90
===================================================================
--- /LMDZ6/branches/cirrus/libf/dyn3d/logic_mod.F90	(revision 5201)
+++ /LMDZ6/branches/cirrus/libf/dyn3d/logic_mod.F90	(revision 5202)
@@ -30,4 +30,6 @@
   LOGICAL hybrid ! vertical coordinate is hybrid if true (sigma otherwise)
                  ! (only used if disvert_type==2)
+  LOGICAL adv_qsat_liq ! true if qsat is calculated alwats wrt liquid for
+                       ! adapted Van Leer advection scheme
   INTEGER iflag_phys ! type of physics to call: 0 none, 1: phy*** package,
                      ! 2: Held & Suarez, 101-200: aquaplanets & terraplanets
Index: /LMDZ6/branches/cirrus/libf/dyn3d/qminimum.F
===================================================================
--- /LMDZ6/branches/cirrus/libf/dyn3d/qminimum.F	(revision 5201)
+++ /LMDZ6/branches/cirrus/libf/dyn3d/qminimum.F	(revision 5202)
@@ -28,4 +28,7 @@
 c     .................................................................
 c
+cDC iq_val and iq_liq are usable for q only, NOT for q_follow
+c   and zx_defau_diag (crash if iq_val/liq==3) => vapor/liquid
+c   water at hardcoded indices 1/2 in these variables
       INTEGER i, k, iq
       REAL zx_defau, zx_abc, zx_pump(ip1jmp1), pompe
@@ -58,37 +61,38 @@
 
       zx_defau_diag(:,:,:)=0.0
-      q_follow(:,:,1:2)=q(:,:,1:2)  
-      DO 1000 k = 1, llm
-        DO 1040 i = 1, ip1jmp1
+      q_follow(:,:,1)=q(:,:,iq_vap)  
+      q_follow(:,:,2)=q(:,:,iq_liq)  
+      DO k = 1, llm
+        DO i = 1, ip1jmp1
           if (seuil_liq - q(i,k,iq_liq) .gt. 0.d0 ) then
 
-              if (niso > 0) zx_defau_diag(i,k,iq_liq)=AMAX1
+            if (niso > 0) zx_defau_diag(i,k,2)=AMAX1
      :               ( seuil_liq - q(i,k,iq_liq), 0.0 )
 
-             q(i,k,iq_vap) = q(i,k,iq_vap) + q(i,k,iq_liq) - seuil_liq
-             q(i,k,iq_liq) = seuil_liq
-           endif
- 1040   CONTINUE
- 1000 CONTINUE
+            q(i,k,iq_vap) = q(i,k,iq_vap) + q(i,k,iq_liq) - seuil_liq
+            q(i,k,iq_liq) = seuil_liq
+          endif
+        ENDDO
+      ENDDO
 c
 c Quand l'eau vapeur est trop faible (ou negative), on complete
 c le defaut en prennant de l'eau vapeur de la couche au-dessous.
 c
-      iq = iq_vap
-c
       DO k = llm, 2, -1
 ccc      zx_abc = dpres(k) / dpres(k-1)
         DO i = 1, ip1jmp1
-          if ( seuil_vap - q(i,k,iq) .gt. 0.d0 ) then
+          if ( seuil_vap - q(i,k,iq_vap) .gt. 0.d0 ) then
 
-            if (niso > 0)
-     &        zx_defau_diag(i,k,iq)=AMAX1( seuil_vap - q(i,k,iq), 0.0 )
+            if (niso > 0) zx_defau_diag(i,k,1)
+     &           = AMAX1( seuil_vap - q(i,k,iq_vap), 0.0 )
 
-            q(i,k-1,iq) =  q(i,k-1,iq) - ( seuil_vap - q(i,k,iq) ) *
-     &                     deltap(i,k) / deltap(i,k-1)
-            q(i,k,iq)   =  seuil_vap  
+            q(i,k-1,iq_vap) = q(i,k-1,iq_vap) - (seuil_vap
+     &           -q(i,k,iq_vap)) * deltap(i,k)/deltap(i,k-1)
+            q(i,k,iq_vap)   =  seuil_vap  
+
           endif
         ENDDO
       ENDDO
+
 c
 c Quand il s'agit de la premiere couche au-dessus du sol, on
@@ -96,6 +100,6 @@
 c
       DO i = 1, ip1jmp1
-         zx_pump(i) = AMAX1( 0.0, seuil_vap - q(i,1,iq) )
-         q(i,1,iq)  = AMAX1( q(i,1,iq), seuil_vap )
+         zx_pump(i) = AMAX1( 0.0, seuil_vap - q(i,1,iq_vap) )
+         q(i,1,iq_vap)  = AMAX1( q(i,1,iq_vap), seuil_vap )
       ENDDO
       pompe = SSUM(ip1jmp1,zx_pump,1)
@@ -121,5 +125,5 @@
       DO i = 1,ip1jmp1
         if (zx_pump(i).gt.0.0) then
-          q_follow(i,1,iq_vap)=q_follow(i,1,iq_vap)+zx_pump(i)
+          q_follow(i,1,1)=q_follow(i,1,1)+zx_pump(i)
         endif !if (zx_pump(i).gt.0.0) then
       enddo !DO i = 1,ip1jmp1
@@ -129,26 +133,26 @@
       do k=2,llm
         DO i = 1,ip1jmp1
-          if (zx_defau_diag(i,k,iq_vap).gt.0.0) then             
+          if (zx_defau_diag(i,k,1).gt.0.0) then             
               ! on ajoute la vapeur en k              
               do ixt=1,ntiso
                q(i,k,iqIsoPha(ixt,iq_vap))=q(i,k,iqIsoPha(ixt,iq_vap))
-     :           +zx_defau_diag(i,k,iq_vap)
-     :           *q(i,k-1,iqIsoPha(ixt,iq_vap))/q_follow(i,k-1,iq_vap)
+     :           +zx_defau_diag(i,k,1)
+     :           *q(i,k-1,iqIsoPha(ixt,iq_vap))/q_follow(i,k-1,1)
                 
               ! et on la retranche en k-1
                q(i,k-1,iqIsoPha(ixt,iq_vap))=
      :            q(i,k-1,iqIsoPha(ixt,iq_vap))
-     :              -zx_defau_diag(i,k,iq_vap)
+     :              -zx_defau_diag(i,k,1)
      :              *deltap(i,k)/deltap(i,k-1)
      :              *q(i,k-1,iqIsoPha(ixt,iq_vap))
-     :              /q_follow(i,k-1,iq_vap)
+     :              /q_follow(i,k-1,1)
 
               enddo !do ixt=1,niso
-              q_follow(i,k,iq_vap)=   q_follow(i,k,iq_vap)
-     :               +zx_defau_diag(i,k,iq_vap)
-              q_follow(i,k-1,iq_vap)=   q_follow(i,k-1,iq_vap)
-     :               -zx_defau_diag(i,k,iq_vap)
+              q_follow(i,k,1)=   q_follow(i,k,1)
+     :               +zx_defau_diag(i,k,1)
+              q_follow(i,k-1,1)=   q_follow(i,k-1,1)
+     :               -zx_defau_diag(i,k,1)
      :              *deltap(i,k)/deltap(i,k-1)
-          endif !if (zx_defau_diag(i,k,iq_vap).gt.0.0) then
+          endif !if (zx_defau_diag(i,k,1).gt.0.0) then
         enddo !DO i = 1, ip1jmp1        
        enddo !do k=2,llm
@@ -161,21 +165,21 @@
         do k=1,llm
         DO i = 1,ip1jmp1
-          if (zx_defau_diag(i,k,iq_liq).gt.0.0) then
+          if (zx_defau_diag(i,k,2).gt.0.0) then
 
               ! on ajoute eau liquide en k en k              
               do ixt=1,ntiso
                q(i,k,iqIsoPha(ixt,iq_liq))=q(i,k,iqIsoPha(ixt,iq_liq))
-     :              +zx_defau_diag(i,k,iq_liq)
-     :              *q(i,k,iqIsoPha(ixt,iq_vap))/q_follow(i,k,iq_vap)
+     :              +zx_defau_diag(i,k,2)
+     :              *q(i,k,iqIsoPha(ixt,iq_vap))/q_follow(i,k,1)
               ! et on la retranche à la vapeur en k
                q(i,k,iqIsoPha(ixt,iq_vap))=q(i,k,iqIsoPha(ixt,iq_vap))
-     :              -zx_defau_diag(i,k,iq_liq)
-     :              *q(i,k,iqIsoPha(ixt,iq_vap))/q_follow(i,k,iq_vap)   
+     :              -zx_defau_diag(i,k,2)
+     :              *q(i,k,iqIsoPha(ixt,iq_vap))/q_follow(i,k,1)   
               enddo !do ixt=1,niso
-              q_follow(i,k,iq_liq)=   q_follow(i,k,iq_liq)
-     :               +zx_defau_diag(i,k,iq_liq)
-              q_follow(i,k,iq_vap)=   q_follow(i,k,iq_vap)
-     :               -zx_defau_diag(i,k,iq_liq)
-          endif !if (zx_defau_diag(i,k,iq_vap).gt.0.0) then
+              q_follow(i,k,2)=   q_follow(i,k,2)
+     :               +zx_defau_diag(i,k,2)
+              q_follow(i,k,1)=   q_follow(i,k,1)
+     :               -zx_defau_diag(i,k,2)
+          endif !if (zx_defau_diag(i,k,1).gt.0.0) then
         enddo !DO i = 1, ip1jmp1
        enddo !do k=2,llm  
Index: /LMDZ6/branches/cirrus/libf/dyn3d/vlspltqs.F
===================================================================
--- /LMDZ6/branches/cirrus/libf/dyn3d/vlspltqs.F	(revision 5201)
+++ /LMDZ6/branches/cirrus/libf/dyn3d/vlspltqs.F	(revision 5202)
@@ -25,5 +25,5 @@
       
       USE comconst_mod, ONLY: cpp
-      
+      USE logic_mod, ONLY: adv_qsat_liq 
       IMPLICIT NONE
 c
@@ -92,5 +92,9 @@
          ENDDO
          DO ij = 1, ip1jmp1
-          zdelta = MAX( 0., SIGN(1., rtt - tempe(ij)) )
+          IF (adv_qsat_liq) THEN
+             zdelta = 0.
+          ELSE
+             zdelta = MAX( 0., SIGN(1., rtt - tempe(ij)) )
+          ENDIF
           play   = 0.5*(p(ij,l)+p(ij,l+1))
           qsat(ij,l) = MIN(0.5, r2es* FOEEW(tempe(ij),zdelta) / play )
